package lel.flummi.skilloverlay.api;

import net.minecraft.client.MinecraftClient;

import java.io.InputStreamReader;
import java.net.URL;

import com.google.gson.Gson;
import com.google.gson.GsonBuilder;

import lel.flummi.skilloverlay.api.records.Profile;
import lel.flummi.skilloverlay.api.records.Profile.Profiles.Member;
import lel.flummi.skilloverlay.config.skilloverlayconfig;

public class PlayerProfile {
    public static Member PROFILE;

    public static void init() {
        String apikey = skilloverlayconfig.get().general.apiKey;
        String uuid = MinecraftClient.getInstance().getSession().getUuidOrNull().toString().replace("-", "");
        String apiurl = "https://api.hypixel.net/skyblock/profiles?key=" + apikey + "&uuid=" + uuid;

        if(apikey.length() > 0) {
            Profile profile = PlayerProfile.updateProfile(apiurl);
            if(profile != null) {
                profile.profiles().removeIf(p -> !p.selected());
                PROFILE = profile.profiles().get(0).members().get(uuid);
            }
            else {
                System.out.println("leer uff");
            }
        }
    }

    public static Profile updateProfile(String apiurl) {
        if(apiurl.length() == 0)
            return null;

        try {
            URL url = new URL(apiurl);
            InputStreamReader reader = new InputStreamReader(url.openStream());
            Gson gson = new GsonBuilder()
                    .serializeNulls()
                    .create();
            return gson.fromJson(reader, Profile.class);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
}
